name = 'Language Mode Plugin'
authors = ['Kuwata Chikara <lawless-882@jeans.ocn.ne.jp>']
version = 0.1
autoload = True
class_name = 'LanguageModePlugin'
short_description = 'Support functions for programming.'
long_description = '''Support functions for programming.'''

class LanguageModePlugin(object):
  def __init__(self, editor):
    self.__editor = editor
    self.__manager = None

  def load(self):
    from SCRIBES.utils import get_language
    from SCRIBES.info import home_plugin_folder
    import LanguageMode
    from imp import load_source
    lang = get_language(self.__editor.uri)
    if lang != None:
      mode = lang.get_id() + 'Mode'
      module = load_source(mode, home_plugin_folder + '/LanguageMode/' + mode + '.py')
      cls = getattr(module, mode)
      self.__manager = cls(self.__editor)
    return
  
  def unload(self):
    if self.__manager != None:
      try:
        self.__manager.destroy()
      except:
        #import traceback
        #traceback.print_exc()
        pass
    return
  
  